from typing import TYPE_CHECKING, Any, Dict, List, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.column_lineage_source_spec import ColumnLineageSourceSpec


T = TypeVar("T", bound="TableLineageSourceSpecColumns")


@_attrs_define
class TableLineageSourceSpecColumns:
    """Configuration of source columns for each column in the current table. The keys in this dictionary are column names
    in the current table. The object stored in the dictionary contain a list of source columns.

    """

    additional_properties: Dict[str, "ColumnLineageSourceSpec"] = _attrs_field(
        init=False, factory=dict
    )

    def to_dict(self) -> Dict[str, Any]:
        pass

        field_dict: Dict[str, Any] = {}
        for prop_name, prop in self.additional_properties.items():
            field_dict[prop_name] = prop.to_dict()

        field_dict.update({})

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        from ..models.column_lineage_source_spec import ColumnLineageSourceSpec

        d = src_dict.copy()
        table_lineage_source_spec_columns = cls()

        additional_properties = {}
        for prop_name, prop_dict in d.items():
            additional_property = ColumnLineageSourceSpec.from_dict(prop_dict)

            additional_properties[prop_name] = additional_property

        table_lineage_source_spec_columns.additional_properties = additional_properties
        return table_lineage_source_spec_columns

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> "ColumnLineageSourceSpec":
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: "ColumnLineageSourceSpec") -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
